
/******************************************************************************
* MODULE     : category.gen.h
* DESCRIPTION: categorial properties of domains
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#module category

/******************************************************************************
* A ring is divisible if we may divide by non zero integers
******************************************************************************/

#define has_divisible<integer>
#define has_divisible<rational>
#define has_divisible<Rational>
#define has_divisible<float>
#define has_divisible<double>
#define has_divisible<fp_real>
#define has_divisible<safe_real>

/******************************************************************************
* A ring has special functions if exp and log have been implemented
******************************************************************************/

/*
#define has_special_functions<float>
#define has_special_functions<double>
*/

/******************************************************************************
* Thresholds for Karatsuba multiplication: must be powers of two
******************************************************************************/

#define Karatsuba_threshold<float>     16
#define Karatsuba_threshold<double>    16
#define Karatsuba_threshold<integer>   16
#define Karatsuba_threshold<rational>  16
#define Karatsuba_threshold<fp_real>    2
#define Karatsuba_threshold<safe_real>  2

/******************************************************************************
* Thresholds for FFT multiplication
******************************************************************************/

#define FFT_threshold<float>     2400
#define FFT_threshold<double>    2400
#define FFT_threshold<integer>   1000
#define FFT_threshold<rational>  1000
#define FFT_threshold<fp_real>   1000
#define FFT_threshold<safe_real> 1000

#endmodule // category
