
/******************************************************************************
* MODULE     : mould.gen.h
* DESCRIPTION: abstract power mould
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <tree.gen.h>
#include <hashmap.gen.h>

#module mould (C, G)
#import tree
#import word (G)
#import hashmap (word<G>, C)

class mould_rep<C,G>: public abstract_struct {
protected:
  hashmap<word<G>,C> coeff;

  inline mould_rep<C,G> (): coeff (0) {}
  inline virtual ~mould_rep<C,G> () {}
  virtual C compute (word<G> w) = 0;

public:
  friend class mould<C,G>;
};

struct mould<C,G> {
#import abstract_null (mould<C,G>, mould_rep<C,G>)
  mould<C,G> (C c, word<G> w= word<G> ());
  C operator [] (word<G> w);
  // operator tree ();
};
#import code_abstract_null (mould<C,G>, mould_rep<C,G>)

void mould<C,G>_set_precision (int n);

// mould<C,G> operator +  (mould<C,G> f, mould<C,G> g);
// mould<C,G> operator -  (mould<C,G> f, mould<C,G> g);
// mould<C,G> operator *  (C c, mould<C,G> f);
// mould<C,G> operator *  (mould<C,G> f, mould<C,G> g);
// mould<C,G> operator /  (mould<C,G> f, mould<C,G> g);

mould<C,G> mould<C,G>_zexp ();
mould<C,G> mould<C,G>_zlog ();

ostream& operator << (ostream& out, mould<C,G> f);

#endmodule // mould (C, G)
